<?php
/*
Plugin Name: Ajax优化
Plugin URI: http://googlo.me
Description: 千言万语，汇成一句：你好云落，提供ajax功能，instantclick预加载
Version: 233
Text Domain: googlo
Author: 云落
Author URI: http://googlo.me
*/


//全站AJAX
function ajax_footer(){
	?>
<script type="text/javascript">

var ajaxhome='googlo.me';
var ajaxcontent = 'content';
var ajaxsearch_class = 'searchform';
var ajaxignore_string = new String('#, /wp-, .pdf, .zip, .rar, /goto');
var ajaxignore = ajaxignore_string.split(', ');
var ajaxloading_code = 'loading';
var ajaxloading_error_code = 'error';

var ajaxreloadDocumentReady = false;
var ajaxtrack_analytics = false
var ajaxscroll_top = true
var ajaxisLoad = false;
var ajaxstarted = false;
var ajaxsearchPath = null;



$(document).ready(function() {
    ajaxloadPageInit("");
});

function submitSearch(param){
    if (!ajaxisLoad){
        ajaxloadPage(ajaxsearchPath, 0, param);
    }
}

function ajaxcheck_ignore(url) {
    for (var i in ajaxignore) {
        if (url.indexOf(ajaxignore[i]) >= 0) {
            return false;
        }
    }
    return true;
}

function ajaxreload_code() {

}

function ajaxclick_code(thiss) {
    $('ul.nav-menu li').each(function() {
        $(this).removeClass('current-menu-item');
    });
    $(thiss).parents('li').addClass('current-menu-item');
}

function ajaxloadPage(url, push, getData){
    if (!ajaxisLoad){
        if (ajaxscroll_top == true) {
            $('html,body').animate({scrollTop: 0}, 500);
        }
        ajaxisLoad = true;
        ajaxstarted = true;
        nohttp = url.replace("http://","").replace("https://","");
        firstsla = nohttp.indexOf("/");
        pathpos = url.indexOf(nohttp);
        path = url.substring(pathpos + firstsla);

        if (push != 1) {
            if (typeof window.history.pushState == "function") {
                var stateObj = { foo: 1000 + Math.random()*1001 };
                history.pushState(stateObj, "ajax page loaded...", path);
            } else {
            }
        }
        if (!$('#' + ajaxcontent)) {
        }
        $('#' + ajaxcontent).append(ajaxloading_code);
        $('#' + ajaxcontent).fadeTo("slow", 0.4,function() {
            $('#' + ajaxcontent).fadeIn("slow", function() {
                $.ajax({
                    type: "GET",
                    url: url,
                    data: getData,
                    <span style="color: #ff0000;">cache: false,</span>
                    dataType: "html",
                    success: function(data) {
                        ajaxisLoad = false;

                        datax = data.split('<title>');
                        titlesx = data.split('</title>');
                        if (datax.length == 2 || titlesx.length == 2) {
                            data = data.split('<title>')[1];
                            titles = data.split('</title>')[0];
                            $(document).attr('title', ($("<div/>").html(titles).text()));
                        } else {

                        }

                        if (ajaxtrack_analytics == true) {
                            if(typeof _gaq != "undefined") {
                                if (typeof getData == "undefined") {
                                    getData = "";
                                } else {
                                    getData = "?" + getData;
                                }
                                _gaq.push(['_trackPageview', path + getData]);
                            }
                        }

                        data = data.split('id="' + ajaxcontent + '"')[1];
                        data = data.substring(data.indexOf('>') + 1);
                        var depth = 1;
                        var output = '';

                        while(depth > 0) {
                            temp = data.split('</div>')[0];
                            i = 0;
                            pos = temp.indexOf("<div");
                            while (pos != -1) {
                                i++;
                                pos = temp.indexOf("<div", pos + 1);
                            }
                            depth=depth+i-1;
                            output=output+data.split('</div>')[0] + '</div>';
                            data = data.substring(data.indexOf('</div>') + 6);
                        }
                        document.getElementById(ajaxcontent).innerHTML = output;
                        $('#' + ajaxcontent).css("position", "absolute");
                        $('#' + ajaxcontent).css("left", "20000px");
                        $('#' + ajaxcontent).show();
                        ajaxloadPageInit("#" + ajaxcontent + " ");

                        if (ajaxreloadDocumentReady == true) {
                            $(document).trigger("ready");
                        }
                        try {
                            ajaxreload_code();
                        } catch(err) {
                        }
                        $('#' + ajaxcontent).hide();
                        $('#' + ajaxcontent).css("position", "");
                        $('#' + ajaxcontent).css("left", "");
                        $('#' + ajaxcontent).fadeTo("slow", 1, function() {});
                    },
                    error: function(jqXHR, textStatus, errorThrown) {
                        ajaxisLoad = false;
                        document.title = "Error loading requested page!";
                        document.getElementById(ajaxcontent).innerHTML = ajaxloading_error_code;
                    }
                });
            });
        });
    }
}
window.onpopstate = function(event) {
    if (ajaxstarted === true && ajaxcheck_ignore(document.location.toString()) == true) {
        ajaxloadPage(document.location.toString(),1);
    }
};
function ajaxloadPageInit(scope){
    $(scope + "a").click(function(event){
        if (this.href.indexOf(ajaxhome) >= 0 && ajaxcheck_ignore(this.href) == true){
            event.preventDefault();
            this.blur();
            var caption = this.title || this.name || "";
            var group = this.rel || false;
            try {
                ajaxclick_code(this);
            } catch(err) {
            }
            ajaxloadPage(this.href);
        }
    });

    $('.' + ajaxsearch_class).each(function(index) {
        if ($(this).attr("action")) {
            ajaxsearchPath = $(this).attr("action");;
            $(this).submit(function() {
                submitSearch($(this).serialize());
                return false;
            });
        }
    });

    if ($('.' + ajaxsearch_class).attr("action")) {} else {
    }
}
</script>
<?php
}
add_action('get_footer','ajax_footer');


//instantclick.js预加载功能
function instantclick(){
?>
	<script type="text/javascript" src="<?php echo plugins_url('/js/instantclick.js', __FILE__); ?>" data-no-instant></script>
	<script data-no-instant>InstantClick.init();</script>
<?php
}
add_action('get_footer','instantclick');

/**
	*WordPress 后台随机颜色
	*/

function Bing_random_admin_color(){
	static $color;
	if( isset( $color ) ) return $color;
	$color = array_keys( $GLOBALS['_wp_admin_css_colors'] );
	$color = $color[array_rand( $color )];
	return $color;
}
add_filter( 'get_user_option_admin_color', 'Bing_random_admin_color' );


?>